Subject: Re: linux-next: manual merge of the akpm tree with Linus' tree

From: Dave Chinner <[email-masked]>
Date: Wed, 11 Sep 2013 10:39:05 +1000

On Tue, Sep 10, 2013 at 05:01:23PM -0700, Linus Torvalds wrote:
> On Tue, Sep 10, 2013 at 4:53 PM, Al Viro <[email-masked]> wrote:
> >
> > list_lru_add() can fail if it's already on the list; leaving the counter
> > alone should've been conditional on that, setting the flag - no.  Said
> > that, it probably should be WARN_ON(!...); this_cpu_inc(); ... |= ...;
> 
> That WARN_ON_(!..) might indeed be better (maybe just WARN_ON_ONCE())..
> 
> That DCACHE_LRU_LIST bit needs to be coherent with "the dentry->d_lru
> entry is on _some_ list" (whether it's the dentry one or the shrinker
> one), so if that list_lru_add() ever fails, that would be a sign of
> badness.
> 
> And that whole function is very performance-critical, to the point
> where we not only don't want to call down to list_lry_add(), we don't
> even want to touch the d_lru list entry itself to even _look_ if it's
> empty or not, because that will take a cache miss. Which was obviously
> the whole reason for that DCACHE_LRU_LIST bit existing...

Guys, I'm about to be out of the office for 4-5 days, so this is
real bad timing for me. When I get back I'll put some effort into
validating that everything still works properly and performs as
expected.

Cheers,

Dave.
-- 
Dave Chinner
[email-masked]